#include "backimg.h"
#include "globdefs.h"
#include "random.h"
#include "sega_gfs.h"
#include "back/bgpal.c"
#include "back/ttpal.c"
#include "cdsound.h"
/* 
 *        IMAGE
 */

#define IMG_NUM 19

Uint32 buffer[120260];

#define   OPEN_MAX  (Sint32)5
#define   DIR_MAX   (Sint32)40 
 
// keep this info global
GfsDirTbl gfsDirTbl;
GfsDirName gfsDirName[DIR_MAX];
Uint32 gfsLibWork[GFS_WORK_SIZE(OPEN_MAX)/sizeof(Uint32)];     

// number of files in current directory
Sint32 gfsDirN;

void backimg_init(){

  // bitmap init;

  /*  slTVOff();
  slInitBitMap(bmNBG1, BM_1024x512,(void *)NBG1_CEL_ADR);
  slBMPaletteNbg1(0);
  slScrPosNbg1(toFIXED(0.0),toFIXED(0.0)); 
  slBitMapBase(0,0);
  slTVOn();
  */

  // cdfunctions init;
  GFS_DIRTBL_TYPE(&gfsDirTbl) = GFS_DIR_NAME;
  GFS_DIRTBL_DIRNAME(&gfsDirTbl) = gfsDirName;
  GFS_DIRTBL_NDIR(&gfsDirTbl) = DIR_MAX;
  gfsDirN = GFS_Init(OPEN_MAX, gfsLibWork, &gfsDirTbl);
}


short int rgbtocol(char r,char g, char b){ 
  short int col =  (b<<10)|(g<<5)|(r);
  return (col & 0x7FFF);
}

void coltorgb(short int col, char* r, char* g, char*b){
  *b = (0x1f) & (col>>10);
  *g = (0x1f) & (col>>5);
  *r = (0x1f) & (col);  
}

void backimg_load_pals(){
  // pal 1
  slDMACopy((void*)ttpal,(void*)(NBG1_COL_ADR+(S2D_PALSIZE/2)*1), (Uint32)S2D_PALSIZE/2);

  // pal 2
  slDMACopy((void*)bgpal,(void*)(NBG1_COL_ADR+(S2D_PALSIZE/2)*2), (Uint32)S2D_PALSIZE/2);

  // pal 3 : faded pal 2
  int i;
  for (i=0;i<256;i++){
    char r,g,b;
    coltorgb(bgpal[i],&r,&g,&b);
    r = 0x1f & (r>>1);
    g = 0x1f & (g>>1);
    b = 0x1f & (b>>1);
    bgpal[i] = rgbtocol(r,g,b);
  }
  slDMACopy((void*)bgpal,(void*)(NBG1_COL_ADR+(S2D_PALSIZE/2)*3), (Uint32)S2D_PALSIZE/2);

}

void backimg_set_pal(int i){
  slBMPaletteNbg1(i);
}

/* 
 *        MOSAIC
 */


#define MOZ_SIZE 6
int imgpos[MOZ_SIZE][XY]={{0,0},{320,0},{640,0},{0,240},{320,240},{640,240}};

FIXED curpos[XY]={0,0};

void backimg_mosaic_cdload_image(char* name, int pos){

  int x,y;

  //  backimg_init();
  //  cdsound_stop();

  Sint32 load = GFS_Load(GFS_NameToId(name), 0, (Uint32 *)buffer, 120260);

  if (load) {
    x = imgpos[pos][X];
    y = imgpos[pos][Y];
    
    slBMPut(x,y,x+319,y+239,(char*)buffer); 
  }
}

void backimg_mosaic_cdload_bimage(int num, int pos){

  num = num%999;
  num = num%IMG_NUM;


  char name[]={'B','0','0','0','.','B','I','N',0};

  name[3] = '0'+num%10;
  name[2] = '0'+(num/10)%10;
  name[1] = '0'+(num/100)%10;

  backimg_mosaic_cdload_image(name,pos);
}

void backimg_mosaic_cdload_aimage(int num, int pos){

  num = num%999;
  num = num%IMG_NUM;


  char name[]={'A','0','0','0','.','B','I','N',0};

  name[3] = '0'+num%10;
  name[2] = '0'+(num/10)%10;
  name[1] = '0'+(num/100)%10;

  backimg_mosaic_cdload_image(name,pos);
}


void backimg_mosaic_cdload_cimage(int num, int pos){

  num = num%999;
  num = num%IMG_NUM;


  char name[]={'C','0','0','0','.','B','I','N',0};

  name[3] = '0'+num%10;
  name[2] = '0'+(num/10)%10;
  name[1] = '0'+(num/100)%10;

  backimg_mosaic_cdload_image(name,pos);
}

void backimg_mosaic_init(){

  backimg_load_pals();

  backimg_mosaic_cdload_aimage(0,SC_TITLE);
  backimg_mosaic_cdload_aimage(1,SC_OPTIONS);

  backimg_mosaic_cdload_aimage(2,SC_PLY);
  backimg_mosaic_cdload_aimage(3,SC_PLY_NT);

  backimg_mosaic_cdload_aimage(4,SC_HELP);

  backimg_mosaic_cdload_bimage(0,SC_GAME);
  backimg_mosaic_goto(SC_TITLE,1);

}

void backimg_mosaic_goto(int i,int nstep){
  FIXED dx,dy;
  FIXED stick = toFIXED(2.0);

  if (i<0) i=0; 
  i = i%MOZ_SIZE;

  dx = toFIXED(1.0*imgpos[i][X])-curpos[X];
  dy = toFIXED(1.0*imgpos[i][Y])-curpos[Y];

  if ((dx>toFIXED(0.0))&&(dx<=stick)){
    curpos[X] =  toFIXED(1.0*imgpos[i][X]);
  } else if  ((dx<toFIXED(0.0))&&(dx>=(-stick))){
    curpos[X] =  toFIXED(1.0*imgpos[i][X]);
  } else {
    curpos[X] += slDivFX(toFIXED(1.0*nstep),dx);
  }

  if ((dy>toFIXED(0.0))&&(dy<=stick)){
    curpos[Y] =  toFIXED(1.0*imgpos[i][Y]);
  } else if  ((dy<toFIXED(0.0))&&(dy>=(-stick))){
    curpos[Y] =  toFIXED(1.0*imgpos[i][Y]);
  } else {
    curpos[Y] += slDivFX(toFIXED(1.0*nstep),dy);
  }

  slScrPosNbg1(curpos[X],curpos[Y]);  
}

void backimg_mosaic_see(int i){
  backimg_mosaic_goto(i,1);
}

void backimg_mosaic_renew_one(int i){
  int image = minmaxrndint(1,IMG_NUM);
  backimg_mosaic_cdload_bimage(image,i);
}

void backimg_mosaic_renew_game_screen(){
  int image = minmaxrndint(1,IMG_NUM);
  backimg_mosaic_cdload_bimage(image,SC_GAME);
}

