#include "sgl.h"
#include "globdefs.h"
#include "item.h"
#include "camion.h"

typedef enum { ps_quiet=0,
	       ps_run1, ps_run2, ps_run3, ps_run4, ps_run5, 
	       ps_down1, ps_down2, ps_down3,
	       ps_up1, ps_up2,
	       ps_hikick1,ps_hikick2,ps_hikick3,ps_hikick4,ps_hikick5,
	       ps_walk1,ps_walk2,ps_walk3,
	       ps_downhit1, ps_downhit2,ps_downhit3,ps_downhit4,
	       ps_jump1,ps_jump2,ps_jump3,ps_jump4,ps_jump5,
	       ps_levelup1,ps_levelup2,ps_levelup3,ps_levelup4,ps_levelup5,
	       ps_hang1,ps_hang2,ps_hang3,ps_hang4,
	       ps_hihand1,ps_hihand2,ps_hihand3,ps_hihand4,ps_hihand5,
	       ps_hf1,ps_hf2,ps_hf3,ps_hf4,
	       ps_nsh1,ps_nsh2,ps_nsh3,ps_nsh4,ps_nsh5,
	       ps_sahl1,ps_sahl2,
	       ps_hihhr1,ps_hihhr2,ps_hihhr3,ps_hihhr4,ps_hihhr5,
	       ps_gardarr1,ps_gardarr2,ps_gardarr3,ps_gardarr4,ps_gardarr5,ps_gardarr6,
	       ps_pfixe1,ps_pfixe2,ps_pfixe3,ps_pfixe4,
	       ps_hangs1,ps_hangs2,ps_hangs3,ps_hangs4,ps_hangs5,ps_hangs6,
	       ps_player_state_last} player_state ;

typedef struct {
  int energy;
  Uint8 zone;
  void* p; // player who hit
} DAMAGE ;


typedef struct  {
  FIXED pos[XYZ];
  int spr_num;
} MARK;

typedef enum { cg_rest=0, cg_patrol1, cg_patrol2, cg_defend, cg_follow, cg_runaway, cg_last,
} cipiu_goal ;

typedef struct {
  int to;
  int padd;
  int padp;
  void* target;
  cipiu_goal goal;
} CIPIU;



typedef struct  {
  player_state state;
  int gr_col;
  int left;
  int energy;
  int mojo;
  int st_timeout;
  FIXED posx;
  FIXED posy;
  FIXED size;
  int level;
  int pad_num;
  MARK m;
  int team;
  DAMAGE damage;
  DAMAGE last_damage;
  int active;
  int score;
  int ndied;
  CIPIU cipiu;
} PLAYER;

#define GA_TIME_LIMIT 0x01
#define GA_TEAM       0x02
#define GA_NEVER_DIE  0x04
#define GA_TRUCK      0x08


typedef struct {
  char flags;
  Uint32 t_limit;
  PLAYER p[MAX_PLAYER];
  ITEM it[MAX_ITEM];
  CAMION c;
} GAME ;

void player_init(PLAYER* p);
void player_display(PLAYER* p);
void player_update_from_control(PLAYER* p, char game_options, GAME* g);
void player_apply_damage(PLAYER* p, int gopt);
void player_collide(PLAYER* p1, PLAYER* p2);
void player_check_boundaries(PLAYER* p);
void player_change_team(PLAYER* p, int team);
void player_get_high(PLAYER*p, FIXED* h);
void player_fall(PLAYER* p);

void game_reinit(GAME* g);
void game_init(GAME* g);
int game_can_begin(GAME* g);
int game_can_end(GAME* g);
void game_item_set(GAME* g, FIXED posx, int level, ITEM_CLASS type);
void game_check_items(GAME* g);
void game_check_camion(GAME* g);
Uint32 game_set_closer_player(GAME *g,PLAYER* p,PLAYER** cl);
void init_collision_data();
//void init_state_sound_data();
 
void damage_copy(DAMAGE* s, DAMAGE* d);

void ground_draw(int s);
void make_pal();

void stats_reset();
void stats_add(int val);
void stats_draw();
