#include "item.h"
#include "screen.h"
#include "globdefs.h"
#include "random.h"
#include "spritesdef.h"

extern TEXTURE tex_spr[];
extern PICTURE pic_spr[];
extern SPR_ATTR attr[];
extern FIXED ground_height[];

void item_init(ITEM* it){
  //  it->posx = minmaxrnd(X_MIN,X_MAX);
  item_reinit(it);
}

void item_reinit(ITEM* it){
  it->active =FALSE;
  //  it->level =  minmaxrndint(0,N_LEVEL-1);
  it->nplayer = -1;
  //  it->type = (slRandom()>toFIXED(0.5))?ic_beer:ic_gun;
}

void item_set(ITEM* it, FIXED posx, int level, ITEM_CLASS type){
  it->posx = posx;
  it->level = level;
  it->nplayer = -1;
  it->type = type;
  it->active = TRUE;
}

void item_display(ITEM* it){
  FIXED pos[XYZSS];
  int spr_num;

  if (it->nplayer != -1) return;
  if (it->active == FALSE) return;

  pos[X] = it->posx;
  pos[Y] = ground_height[it->level]+toFIXED(+16.0-4.0);
  pos[Z] = toFIXED(175.0);
  pos[S] = toFIXED(1.0);
  pos[4] = toFIXED(1.0);
  switch (it->type){
  case ic_beer : spr_num = SP_BEER; break;
    //  case ic_gun : spr_num = SP_GUN; break;
    //  default: spr_num = FIRST_MARK; 
  default : spr_num = SP_BEER; break;
  }

  attr[spr_num].gstb = CL_Gouraud;
  slDispSpriteHV(pos,(SPR_ATTR *)(&attr[spr_num]),0x0);   
}
