#include "sl_def.h"
#include "sgl.h"
#include "libpad.h"
#include "spritesdef.h"
#include "random.h"
#include "sprites/spr_pal.pal"
#include "globdefs.h"
#include "screen.h"
#include "gameobj.h"
#include "sound.h"
#include "expl.h"
#include "cdsound.h"
#include "gouraud.h"
#include "music.h"
#include "backimg.h"

/*
 * BAH
 */

int orteams[MAX_PLAYER];

/*
 *
 */
extern int p_pad[];

void contest_return(){
  int i;
  for (i=0;i<MAX_PAD_NB;i++){
    Uint16 padd = ~(Smpc_Peripheral[p_pad[i]].data);
    //    Uint16 padp = ~(Smpc_Peripheral[p_pad[i]].push);
    if ((padd & PER_DGT_TA) && 
	(padd & PER_DGT_TB) && 
	(padd & PER_DGT_TC) && 
	(padd & PER_DGT_ST))
      SYS_Exit(0);      
  }
}

/*
 * PAD
 */

extern int p_pad[]; // physical pad number


/*
 * SPRITES
 */ 

extern TEXTURE tex_spr[];
extern PICTURE pic_spr[];
extern SPR_ATTR attr[];
static void set_sprite(PICTURE *pcptr , Uint32 NbPicture)
{
  TEXTURE *txptr;

  for(; NbPicture-- > 0; pcptr++){
    txptr = tex_spr + pcptr->texno;
    slDMACopy((void *)pcptr->pcsrc,
	      (void *)(SpriteVRAM + ((txptr->CGadr) << 3)),
	      (Uint32)((txptr->Hsize * txptr->Vsize * 4) >> (pcptr->cmode)));
  }
}

/*
 * Superb Functions
 */
void clear_screen(){
  /*  int i,j;
      for (i=0;i<50;i++){
      for (j=0;j<50;j++){
      slPrint(" ",slLocate(i,j));
      }
      }
  */
}

void randomize() {
  int out = FALSE;
  FIXED useless = toFIXED(666.0);
  while (!out){
    slSynch();
    contest_return();

    useless = slRandom();
    out = pad_someone_presses(PER_DGT_ST, TRUE);
  }
}


void gfx_init(){
  slInitSystem(TV_320x240, tex_spr,1); 

  

  slColRAMMode(CRM16_2048);

  //  slDMACopy((void*)S2D_SPR_PAL, (void*)(NBG1_COL_ADR+S2D_PALSIZE), (Uint32)S2D_PALSIZE);
  slDMACopy((void*)S2D_SPR_PAL, (void*)(NBG1_COL_ADR), (Uint32)S2D_PALSIZE/2);

  slInitBitMap(bmNBG1, BM_1024x512,(void *)NBG1_CEL_ADR);
  slBMPaletteNbg1(0);
  slScrPosNbg1(toFIXED(0.0),toFIXED(0.0)); 
  slBitMapBase(0,0);
  
  set_sprite(pic_spr, PICTURE_NB);
  slColOffsetOn(SPRON);
  slColorCalc( CC_RATE | CC_TOP | RBG0ON | NBG1ON|SPRON);
  slColorCalcOn( RBG0ON |NBG1ON|SPRON);
  slColRateLNCL(0x1f);
  
  gouraud_table_to_vram();
  
  slSpriteCCalcCond(CC_pr_CN) ;
  slSpriteCCalcNum(7) ;
  slSpriteColMode(SPR_PAL_RGB) ;
  //   slSpriteWinMode(Uint16) ;
  slSpriteType(1) ;
  
  slScrAutoDisp(NBG1ON);
  //slScrAutoDisp(NBG0ON); 

  slBMBoxFill(0,0,320,240,135);

}


void test_lines(){
  int col;
  slBMBoxFill(0,0,320,240,0);
  for (col=0;col<256;col++){
    slBMLine(col,0,col,240,col);
  }
}

void debug_sound(){
  static int st = 0;
  clear_screen();

  slSynch();
  contest_return();

  while(!pad_someone_presses(PER_DGT_ST,TRUE)){
    sound_channel_state_get();
    sound_channel_print(10,1);
    if (pad_someone_presses(PER_DGT_TA,TRUE)) st--;
    if (pad_someone_presses(PER_DGT_TB,TRUE)) st++;

    if (pad_someone_presses(PER_DGT_TA|PER_DGT_TB,TRUE)) { 
      if (st>=vs_last) st = vs_last-1;
      if (st==-1)      st = 0;
      sound_pcm_gfx_display(st,-150,-70,150,110);
      sound_pcm_display_name(st,10,25);
    }

    if (pad_someone_presses(PER_DGT_TX,TRUE)) {
      sound_tell(st,1);
    }
    if (pad_someone_presses(PER_DGT_TY,TRUE)) {
      sound_tell(st,2);
    }
    if (pad_someone_presses(PER_DGT_TZ,TRUE)) {
      sound_tell(st,3);
    }

    sound_step();
    slSynch();
    contest_return();

    

  }
}

void displaybinint8(int num, int x, int y){
  int i;
  for (i=0;i<16;i++){
    if (num&(1<<i))
      slPrint("1",slLocate(x-i+7,y));
    else 
      slPrint("0",slLocate(x-i+7,y));
  }
}

void debug_display_all_sprites(){
  int i;
  FIXED pos[] = {toFIXED(0.0),toFIXED(0.0),toFIXED(169.0),toFIXED(1.0),toFIXED(1.0)};
  static ANGLE ang = 0;
  FIXED x,y;
  static int zoom=9;
  static FIXED xoff = toFIXED(0.0);
  static FIXED yoff = toFIXED(0.0);

  int chop = TRUE;
  Uint16 sprout = CL256Bnk;//|CL_Gouraud;
  int mark = 0;

  slSynch();
  contest_return();


  int sprcolno = (0x000);//(0x200);
  while(!pad_someone_presses(PER_DGT_ST,TRUE)){
    
    if (pad_someone_presses(PER_DGT_TL,TRUE)){
      sprcolno -= 0x100;
    } else if (pad_someone_presses(PER_DGT_TR,TRUE)){
      sprcolno += 0x100;
    }
    slPrintHex(sprcolno,slLocate(10,1));

    slPushUnitMatrix();
    {
      if (pad_someone_presses(PER_DGT_TC,TRUE)){
	chop = (chop)?FALSE:TRUE;
      }
      if (chop){

	if (pad_someone_presses(PER_DGT_TA,FALSE)){
	  zoom--;
	} 
	if (pad_someone_presses(PER_DGT_TB,FALSE)){
	  zoom++;
	}
	
	if (pad_someone_presses(PER_DGT_KU,FALSE)){
	  yoff -= toFIXED(1.0);
	} 
	if (pad_someone_presses(PER_DGT_KD,FALSE)){
	  yoff += toFIXED(1.0);
	} 
	if (pad_someone_presses(PER_DGT_KL,FALSE)){
	  xoff -= toFIXED(1.0);
	} 
	if (pad_someone_presses(PER_DGT_KR,FALSE)){
	  xoff += toFIXED(1.0);
	}
	
      } else {
	if (pad_someone_presses(PER_DGT_KL,TRUE)){
	  mark++;
	}
	if (pad_someone_presses(PER_DGT_KR,TRUE)){
	  mark--;
	}
	if (mark<0) mark =0;
	if (mark>15) mark =15;
	if (pad_someone_presses(PER_DGT_TA,TRUE)){
	  if (sprout&(1<<mark))
	    sprout = sprout&(~(1<<mark));
	  else 
	    sprout = sprout|(1<<mark);
	}
	if (pad_someone_presses(PER_DGT_TB,TRUE)){
	  sprout = (CL256Bnk);
	}
	slPrint("                                    ",slLocate(1,3));
	slPrint("x",slLocate(10+7-mark,3));
	displaybinint8(sprout,10,2);
	
      }

   

      x = X_MIN+toFIXED(16.0)-toFIXED(40.0);
      y = Y_MIN+toFIXED(16.0);        
    
      for (i=0;i<SPRITE_NB;i++){
	x = x + toFIXED(40.0);
	if (x>(X_MAX-toFIXED(16.0))) {
	  x = X_MIN+toFIXED(16.0);
	  y += toFIXED(40.0);
	}
      
	pos[X] = x;
	pos[Y] = y;

      
	slPushMatrix();
	{
	  FIXED fzoom = toFIXED(zoom*1.0);
	  slTranslate(xoff,yoff,toFIXED(169.0)+fzoom);
	  attr[i].colno =  sprcolno;
	  attr[i].atrb = sprout;
	  attr[i].gstb =  GRaddr+i%12;//+minmaxrnd(0,11);
	  slPutSprite(pos, (SPR_ATTR *)(&attr[i]),ang);
	}
	slPopMatrix();
      
      }
    }
    slPopMatrix();
    slSynch();
    contest_return();

    
  }
}		      

void displaybinint16(int num, int x, int y){
  int i;
  for (i=0;i<16;i++){
    if (num&(1<<i))
      slPrint("1",slLocate(x-i+7,y));
    else 
      slPrint("0",slLocate(x-i+7,y));
  }
}



void debug_gouraud(){

  int i;
  FIXED x,y;
  FIXED pos[] = {toFIXED(0.0),toFIXED(0.0),toFIXED(169.0),toFIXED(1.0),toFIXED(1.0)};
  Uint16 sprout[4];
  int mark=0;
  int mark2=0;
  int spr_num = 0;
  int cur = spr_num;

  slSynch();
  contest_return();

  for (i=0;i<4;i++){
    gouraud_table_set(i,sprout[i]);
  }

  while(!pad_someone_presses(PER_DGT_ST,TRUE)){

    x = toFIXED(0.0); 
    y = toFIXED(20.0);

    for (i=0;i<4;i++){
      slPrintHex(sprout[i],slLocate(20,2+(i*2)));
      displaybinint16(sprout[i],10,2+(i*2));
      slPrint("                                     ",slLocate(0,3+(i*2)));
      if (i==mark2) 
	slPrint("^",slLocate(17-mark,3+(i*2)));
    }


    if (pad_someone_presses(PER_DGT_KL,TRUE)) mark++;
    if (pad_someone_presses(PER_DGT_KR,TRUE)) mark--;
    if (pad_someone_presses(PER_DGT_KD,TRUE)) mark2++;
    if (pad_someone_presses(PER_DGT_KU,TRUE)) mark2--;
    if (pad_someone_presses(PER_DGT_TC,TRUE)) cur++;
    if (pad_someone_presses(PER_DGT_TB,TRUE)) cur--;

    if (mark<0) mark =0;
    if (mark>15) mark =15;

    if (mark2<0) mark2 =0;
    if (mark2>3) mark2 =3;

    if (cur<0) cur = 0;
    if (cur>=SPRITE_NB) cur = SPRITE_NB-1;

    if (pad_someone_presses(PER_DGT_TA,TRUE)){
      sprout[mark2] = (sprout[mark2])^(1<<mark);
      for (i=0;i<4;i++){
	gouraud_table_set(i,sprout[i]);
      }
      gouraud_table_to_vram();
    }

    if (pad_someone_presses(PER_DGT_TX,TRUE)){
      sprout[mark2] ^=  (1<<mark);
      for (i=0;i<4;i++){
	if ((sprout[mark2])&(1<<mark)){
	  sprout[i] |= (1<<mark);
	} else {
	  sprout[i] &= ~(1<<mark);
	}
	gouraud_table_set(i,sprout[i]);
      }
      gouraud_table_to_vram();
    }


    pos[X] = x-toFIXED(70);
    pos[Y] = y;
    pos[S] = toFIXED(4.0);
    attr[cur].atrb ^= CL_Gouraud;
    slPutSprite(pos, (SPR_ATTR *)(&attr[cur]),0x0);

    pos[X] = x+toFIXED(70.0);
    pos[Y] = y;
    pos[S] = toFIXED(4.0);
    attr[cur].atrb |= CL_Gouraud;
    attr[cur].gstb =  GRaddr;
    slPutSprite(pos, (SPR_ATTR *)(&attr[cur]),0x0);

    for (i=0;i<12;i++){
      pos[X] = toFIXED((16.0*i)-96.0);
      pos[S] = toFIXED(2.0);
      spr_num = FIRST_MARK+i;


      pos[Y] = toFIXED(109.0);
      attr[spr_num].atrb |= CL_Gouraud;
      attr[spr_num].gstb =  GRaddr;
      slPutSprite(pos, (SPR_ATTR *)(&attr[spr_num]),0x0);

      pos[Y] = toFIXED(93.0);
      attr[spr_num].atrb ^= CL_Gouraud;
      slPutSprite(pos, (SPR_ATTR *)(&attr[spr_num]),0x0);
     
    }

    slSynch();
    contest_return();
 
  }
}
/*
 * INTRO
 */

void si_display_skm(){
  static FIXED pos[] = {toFIXED(0.0),toFIXED(0.0),toFIXED(169.0),toFIXED(2.0),toFIXED(8.0)};
  static int logo=1;
  static ANGLE angx = 0x0;
  //  angx = angx+DEGtoANG(2.0);

  logo = !logo;
  
  int spr_num = logo?SP_TITLE:SP_TITLE+1;

  //  spr_num = SP_TITLE+1;

  FIXED sx,sy;
  sx = 0;
  sy = 0;

  sx += slMulFX(toFIXED(3.0),slRandom()-toFIXED(0.5));
  sy += slMulFX(toFIXED(4.0),slRandom()-toFIXED(0.5));

  pos[X] += sx;
  pos[Y] += sy;

  attr[spr_num].atrb = CL256Bnk|CL_Gouraud;
  attr[spr_num].gstb = GRaddr + minmaxrnd(0,12);
  slDispSprite(pos, (SPR_ATTR *)(&attr[spr_num]),angx);   
}

void si_rotate_pal(unsigned short* lpal,int way){

  unsigned short a;
  int i;

  if (way == -1){
    a = lpal[0];
    for (i=1;i<256;i++){
      lpal[i-1] = lpal[i];
    }
    lpal[255] = a;
  } else {
    a = lpal[255];
    for (i=255;i>0;i--){
      lpal[i] = lpal[i-1];
    }
    lpal[0] = a;
  }
}

void sub_intro(){
  unsigned short lpal[256];
  int i;
  static FIXED posx=0;
  static FIXED posy=0;
  static FIXED dx=toFIXED(-10.0);
  static FIXED dy=toFIXED(0.0);
  FIXED maxyy=toFIXED(240.0);
  FIXED minyy=toFIXED(0.0);
  FIXED maxxx=toFIXED(640.0);
  FIXED minxx=toFIXED(0.0);
  int wioffset = 0;
  GAME g;
  game_init(&g);
  int ct=1;

  for (i=0;i<MAX_PLAYER;i++){
    PLAYER* p = &(g.p[i]);
    player_init(p);
    p->pad_num = -1;
    p->active = (i<5);
    p->team = i%MAX_TEAM;
    p->level = i%3;
      
  }

  slTVOff();
  for (i=0;i<256;i++){
    lpal[i] = spr_palPal[i];
  }
  lpal[0] = lpal[1] = rgbtocol(0x1F,0,0);

  ct = !ct;
  if (ct) {
    slDMACopy((void*)lpal,(void*)(NBG1_COL_ADR+(S2D_PALSIZE/2)*4), (Uint32)S2D_PALSIZE/2);    
  }

  backimg_set_pal(4);

  for (i=0;i<6;i++){
    backimg_mosaic_cdload_cimage(i,i);
    backimg_mosaic_see(i);
  }
  
  //  cdsound_play(2,2,0);

  slTVOn();

  do {
    for (i=0;i<MAX_PLAYER;i++){
      PLAYER* p = &(g.p[i]);
      if (p->active){
	player_update_from_control(p,g.flags,&g);
	//	player_check_boundaries(p);

	player_display(p);
      }
    }

    si_display_skm();    
    if (wioffset>3) wioffset= 3;
    if (wioffset<-3) wioffset= -3;
    
    int nturn = (wioffset>0)?wioffset:-wioffset;
    for (i=0;i<(nturn);i++){
      si_rotate_pal(lpal,(nturn == wioffset)?1:-1);
    }

    slDMACopy((void*)lpal,(void*)(NBG1_COL_ADR+(S2D_PALSIZE/2)*4), (Uint32)S2D_PALSIZE/2);
    
    if (dx>toFIXED(5.0)) dx = toFIXED(5.0);
    if (dx<toFIXED(-5.0)) dx = toFIXED(-5.0);

    if (dy>toFIXED(5.0)) dy = toFIXED(5.0);
    if (dy<toFIXED(-5.0)) dy = toFIXED(-5.0);

    posx += dx;
    posy += dy;

    if (posx>maxxx){
      dx = slMulFX(toFIXED(-1.0),dx);
      posx = maxxx;
      dy += minmaxrnd(toFIXED(-1.0),toFIXED(1.0));
      wioffset++;
    }
    if (posx<minxx){
      dx = slMulFX(toFIXED(-1.0),dx);
      posx = minxx;
      dy += minmaxrnd(toFIXED(-1.0),toFIXED(1.0));
      wioffset++;
    }

    if (posy>maxyy){
      dy = slMulFX(toFIXED(-1.0),dy);
      posy = maxyy;
      dx += minmaxrnd(toFIXED(-1.0),toFIXED(1.0));
      wioffset--;
    }
    if (posy<minyy){
      dy = slMulFX(toFIXED(-1.0),dy);
      posy = minyy;
      dx += minmaxrnd(toFIXED(-1.0),toFIXED(1.0));
      wioffset--;
    }

    slScrPosNbg1(posx,posy);  
  

  
    slRandom();

    slSynch();
    contest_return();

  } while (!pad_someone_presses(PER_DGT_ST,TRUE));

  //  cdsound_stop();
}



/*
 * TITLE SCREEN
 */

void st_rotate(Uint32* ppal,Uint32 psize){
  Uint32 mem = *(ppal);
  int i;
  for (i=0;i<(psize-1);i++){
    *(ppal) = *(ppal+1);
    ppal++;
  }
  (*ppal) = mem;
}


void st_display_buttons(){
  static FIXED pos[] = {toFIXED(100.0),toFIXED(100.0),toFIXED(169.0),toFIXED(2.0)};
  static FIXED inc = toFIXED(0.02);
  
  pos[S] += inc ;
  if ((pos[S]>toFIXED(2.0))||(pos[S]<toFIXED(1.0))){
    inc = slMulFX(toFIXED(-1.0),inc);
  }

  int spr_num = SP_BUT_ST;
  attr[spr_num].atrb =  CL256Bnk;//|CL_Gouraud;
  //  attr[spr_num].gstb = GRaddr + minmaxrndint(0,16);
  slDispSprite(pos, (SPR_ATTR *)(&attr[spr_num]),0x0);   
  
}
/*
 * HELP
 */


void sub_help(){

  backimg_set_pal(PN_TITLE);

  do {    
    backimg_mosaic_goto(SC_HELP,20);
    slSynch();
    contest_return();

  } while (!pad_someone_presses(PER_DGT_ST, TRUE));  
  slSynch();
  contest_return();

}

void sub_title(){

  backimg_set_pal(PN_TITLE);
  backimg_mosaic_goto(SC_TITLE,1);


  int tt=-100;int tu=0;
  int csee=SC_TITLE;
  int cpal=PN_TITLE;

  do {    
    if (pad_someone_presses(PER_DGT_KL,TRUE)) csee--;
    if (pad_someone_presses(PER_DGT_KR,TRUE)) csee++;

    if (csee<0) csee =0;
    if (csee>5) csee =5;

    if (pad_someone_presses(PER_DGT_KD,TRUE)) cpal--;
    if (pad_someone_presses(PER_DGT_KU,TRUE)) cpal++;

    if (cpal<0) cpal = 0;
    if (cpal>7) cpal = 7;

    backimg_mosaic_goto(csee,20);
    backimg_set_pal(cpal);

    /*    if (pad_someone_presses(PER_DGT_TA,TRUE)) {
	  cpic++;
	  backimg_mosaic_cdload_bimage(cpic,csee);
	  }*/

    if (++tu>1000){
      tu = 0;
      //      backimg_mosaic_renew_one(minmaxrndint(1,5));
    }
    if (++tt>300) {
      tt = 0;
      //   see = minmaxrndint(0,5);
    }

    //    backimg_mosaic_goto(see,30);		   
    //    slPrintFX(slRandom(),slLocate(11,29));
    music_play();

    st_display_buttons();
    slSynch();
    contest_return();

    
    if (pad_someone_presses(PER_DGT_TB,TRUE)) sub_help();
  } while (!pad_someone_presses(PER_DGT_ST, TRUE));  
  
}


/*
 * GAME TYPE
 */

FIXED sgt_goto(FIXED s,FIXED d,FIXED r){
  FIXED val;
  val = s+slMulFX(d-s,r);
  return val;
  
}

void sub_game_type(GAME* g){
  int i;

  static FIXED pos[4][XYZS];
  int last_changed = 0;
  int to=100;

  pos[0][Y] = toFIXED(0.0);
  pos[0][X] = toFIXED(-90.0);
  pos[1][Y] = toFIXED(0.0);
  pos[1][X] = toFIXED(-30.0);
  pos[2][Y] = toFIXED(0.0);
  pos[2][X] = toFIXED(30.0);
  pos[3][Y] = toFIXED(0.0);
  pos[3][X] = toFIXED(90.0);

  for (i=0;i<4;i++){
    pos[i][Z] = toFIXED(169.0);       
  }

  backimg_set_pal(PN_TITLE);

  sound_tell(vs_sine,1);
  do {
    sound_step() ;   

    to--;
    if (to<0) to =0;

    backimg_mosaic_goto(SC_OPTIONS,10);

    last_changed =0;
    // read input
    if (pad_someone_presses(PER_DGT_TA, TRUE)) last_changed = GA_TIME_LIMIT;
    if (pad_someone_presses(PER_DGT_TB, TRUE)) last_changed = GA_TEAM;
    if (pad_someone_presses(PER_DGT_TC, TRUE)) last_changed = GA_NEVER_DIE;
    if (pad_someone_presses(PER_DGT_TX, TRUE)) last_changed = GA_TRUCK;
    
    g->flags ^= last_changed;

    if (last_changed == GA_TEAM) {
      if (g->flags & GA_TEAM) 
	if (g->flags & GA_NEVER_DIE)
	  g->flags ^= GA_NEVER_DIE;
    }

    if (last_changed == GA_NEVER_DIE) {
      if (g->flags & GA_NEVER_DIE) 
	if (g->flags & GA_TEAM)
	  g->flags ^= GA_TEAM;
    }

    if (last_changed) 
      sound_tell(minmaxrndint(vs_step1,vs_step6),1);


    // display bonus states
    for (i=0;i<4;i++){
      if (g->flags & (1<<i)){
	pos[i][X] = sgt_goto(pos[i][X],toFIXED(-75.0)+toFIXED(50.0*i),toFIXED(0.6));
	pos[i][S] = sgt_goto(pos[i][S],toFIXED(1.0),toFIXED(0.6));
	pos[i][Y] = sgt_goto(pos[i][Y],toFIXED(0.0),toFIXED(0.4));
      } else {
	pos[i][X] = sgt_goto(pos[i][X],toFIXED(-48.0)+toFIXED(32.0*i),toFIXED(0.6));
	pos[i][S] = sgt_goto(pos[i][S],toFIXED(0.5),toFIXED(0.6));
	pos[i][Y] = sgt_goto(pos[i][Y],toFIXED(-100.0),toFIXED(0.4));
      }
      slDispSprite(pos[i], (SPR_ATTR *)(&attr[SP_GOPT_TIME_LIMIT+i]),0x0);   
    }
    slSynch();
    contest_return();

    
  } while ((!pad_someone_presses(PER_DGT_ST, TRUE))||(to>0));  

}


/*
 * PLAYERS and TEAM choice
 */ 

/*
  void spat_draw_boxes(){
  slBMBoxFill(-160+160,-120+120,160+160,120+120,2);
  slBMBoxFill(-160+160,90+120,160+160,120+120,17);
  }
*/

int spat_find_first_zero(int* tab,int beg){
  int num = -1;
  int i;
  for (i=0;((i<MAX_PLAYER)&&(num==-1));i++){
    int idx  = (i+beg+1)%MAX_PLAYER;
    if (tab[idx]==0)
      num=idx;
  }
  return num;
}


void spat_display_buttons(){
  static FIXED pos[] = {toFIXED(100.0),toFIXED(100.0),toFIXED(169.0),toFIXED(1.0)};
  static FIXED inc = toFIXED(0.01);
  
  pos[S] += inc ;
  if ((pos[S]>toFIXED(1.2))||(pos[S]<toFIXED(1.0))){
    inc = slMulFX(toFIXED(-1.0),inc);
  }

  int spr_num = SP_BUT_ST;
  attr[spr_num].atrb =  CL256Bnk;//|CL_Gouraud;
  //  attr[spr_num].gstb = GRaddr + minmaxrndint(0,16);
  slDispSprite(pos, (SPR_ATTR *)(&attr[spr_num]),0x0);   
  
}

int find_first_inactive_player(GAME* g){
  int i=0;
  int num=-1;
  for (i=0;((num==-1)&&(i<MAX_PLAYER));i++){
    if (!(g->p[i].active))
      num = i;
  }
  return num;
}

int find_player_from_pad(GAME* g, int pad_num){
  int i=0;
  int pl = -1;
  for (i=0;((pl==-1)&&(i<MAX_PLAYER));i++){
    PLAYER* p = &(g->p[i]);
    if (p->active){
      if (p->pad_num == pad_num)
	pl = i;
    }
  }
  return pl;
}


void sub_players_and_teams(GAME* g){
  int i;
  int out=FALSE;
  int gour[MAX_PLAYER];
  int dto = 1;
  int last_team = 0;
  slSynch();
  contest_return();


  //  spat_draw_boxes();

  sound_tell(vs_sine,0);
  for (i=0;i<MAX_PLAYER;i++){
    gour[i] = 0;
  }

  gouraud_restore_pl();
  gouraud_table_to_vram();

  for (i=0;i<MAX_PLAYER;i++){
    g->p[i].active = FALSE;
    g->p[i].gr_col = GRaddr+i%12;
  }

  backimg_set_pal(PN_TITLE);

  while (!out){
    
    backimg_mosaic_goto((g->flags & GA_TEAM)?SC_PLY:SC_PLY_NT,10);

    dto++;
    
    for (i=0;i<MAX_PAD;i++){

      PLAYER* p = (PLAYER*)0;
      int cur_player = find_player_from_pad(g,p_pad[i]);
      if (cur_player == -1){
	int ppp =  find_first_inactive_player(g);
	if (ppp!=-1) {
	  p = &(g->p[ppp]);	  
	}
      } else {
	p = &(g->p[cur_player]);
      }

      Uint16 padp = ~(Smpc_Peripheral[p_pad[i]].push);

      //      Uint16 padd = ~(Smpc_Peripheral[p_pad[i]].data);    
      
      if (p){
	if (p->active){
	  if (padp & PER_DGT_TA) {
	    int cc = spat_find_first_zero(gour,p->gr_col-GRaddr);
	    if (cc!=-1){
	      sound_tell(vs_sine,2);
	      gour[p->gr_col-GRaddr]=FALSE;
	      p->gr_col = GRaddr+cc;
	      gour[cc]=TRUE;
	    }
	  }
	  if (padp & PER_DGT_TC) {
	    sound_tell(vs_sine,2);
	    p->active = FALSE;
	    gour[p->gr_col-GRaddr]=FALSE;
	  }
	  if (padp & PER_DGT_TB) {
	    sound_tell(vs_sine,3);
	    player_change_team(p,((p->team)+1)%MAX_TEAM);
	    last_team = p->team;	  
	    p->posy=minmaxrnd(toFIXED(-40.0),toFIXED(60.0));
	    p->posx=toFIXED(-160.0)+toFIXED(20.0)+toFIXED(100.0*p->team+minmaxrndint(0,80));
	  }

	  if (padp & PER_DGT_TX) {
	    sound_tell(vs_hit1,3);
	    p->pad_num = -1;
	  }
	  
	  if (padp & PER_DGT_KU){
	    int prosir;
	    for (prosir=0;prosir<4;prosir++){
	      gouraud_table_set((p->gr_col-GRaddr)*4+prosir,
				(Uint16)((slRandom()|0x210)&(~(Uint16)0x4000)));
	    }
	    gouraud_table_to_vram();
	  }
	  
	} else {
	  if (padp & PER_DGT_TA){
	    int cc = spat_find_first_zero(gour,0);
	    if (cc!=-1){
	      p->level = 1;
	      sound_tell(vs_sine,1);
	      player_change_team(p,(++last_team)%MAX_TEAM);
	      p->active = TRUE;
	      p->gr_col = GRaddr+cc;
	      gour[p->gr_col-GRaddr]=TRUE;
	      p->pad_num = p_pad[i];
	      p->posy=minmaxrnd(toFIXED(-40.0),toFIXED(60.0));
	      p->posx=toFIXED(-160.0)+toFIXED(20.0)+toFIXED(100.0*p->team+minmaxrndint(0,80));
	    }
	  }
	}
      }
    }

    for (i=0;i<MAX_PLAYER;i++){
      if (g->p[i].active)
	player_display(&(g->p[i]));
    }
    if (game_can_begin(g)>1)
      spat_display_buttons();

    out = (pad_someone_presses(PER_DGT_ST,TRUE) && (game_can_begin(g)>1));

    sound_step();
    slSynch();
    contest_return();

    

  }
}

/*
 * MATCH
 */

int sm_add_player(GAME* g,int pad_num){

  int foundp = find_player_from_pad(g,pad_num);
  int idx = find_first_inactive_player(g);

  if (idx != -1){
    PLAYER * p = &(g->p[idx]);
    p->active = TRUE;
    if (!foundp) {
      p->pad_num = pad_num;
    } else {
      p->pad_num = -1;
    }    
  }
  return idx;
}


void explCRAM(void *Col_Adr , Uint32 su){
  Uint16 *VRAM;
  VRAM = (Uint16 *)Col_Adr;
  
  while (su>0){
    (*VRAM) = (Uint16) minmaxrndint(0x0,0xFFFF);
    VRAM++;
    su--;
  }
}

int sm_check_pause_command(int minplayer){

  static int pause_num = 0;
  static int pause_to = 0;

  if (pad_someone_presses(PER_DGT_ST, FALSE)){
    pause_to--;
    if (pad_someone_presses(PER_DGT_ST, TRUE)){
      if (pause_num < (minplayer-1)){
	pause_num++;
	pause_to+=120;
      } else {
	pause_num = 0;
	pause_to = 0;
	return(TRUE);
      }
    }
    if (pause_to<0){
      pause_num=0;
    }
  } else {
    pause_to = 0;
    pause_num = 0;
  }
  return FALSE;
}

int sm_get_n_h_player(GAME *g){
  int i;
  int n_player = 0;
  for (i=0;i<MAX_PLAYER;i++){
    n_player += ((g->p[i].active)&&(g->p[i].pad_num!=-1))?1:0;
  }
  return n_player;
}

void sm_display_pause_buttons(){

  static FIXED posA[] = {toFIXED(0.0),toFIXED(-20.0),toFIXED(169.0),toFIXED(2.0)};
  static FIXED posB[] = {toFIXED(100.0),toFIXED(100.0),toFIXED(169.0),toFIXED(1.0)};
  static FIXED posC[] = {toFIXED(0.0),toFIXED(10.0),toFIXED(169.0),toFIXED(1.1)};
  static FIXED incB = toFIXED(0.01);
  static FIXED incC = toFIXED(0.06);
  
  int spr_num = SP_BUT_PAUSE;
  attr[spr_num].atrb =  CL256Bnk;//|CL_Gouraud;
  //  attr[spr_num].gstb = GRaddr + minmaxrndint(0,1);

  slDispSprite(posA, (SPR_ATTR *)(&attr[spr_num]),0x0);   


  posB[S] += incB ;  
  if ((posB[S]>toFIXED(1.2))||(posB[S]<toFIXED(1.0))){
    incB = slMulFX(toFIXED(-1.0),incB);
  }

  spr_num = SP_BUT_C1;
  attr[spr_num].atrb =  CL256Bnk;//|CL_Gouraud;
  //  attr[spr_num].gstb = GRaddr + minmaxrndint(0,16);

  slDispSprite(posB, (SPR_ATTR *)(&attr[spr_num]),0x0);   

  posC[S] += incC ;  
  if ((posC[S]>toFIXED(1.3))||(posC[S]<toFIXED(1.0))){
    incC = slMulFX(toFIXED(-1.0),incC);
  }

  spr_num = SP_BUT_ST;
  attr[spr_num].atrb =  CL256Bnk;//|CL_Gouraud;
  //  attr[spr_num].gstb = GRaddr + minmaxrndint(0,16);

  if (posC[S]>toFIXED(1.2))
    slDispSprite(posC, (SPR_ATTR *)(&attr[spr_num]),0x0);   



}

void sm_display_prepare(){
  static FIXED pos[] = {toFIXED(0.0),toFIXED(0.0),toFIXED(166.0),toFIXED(2.0)};
  static FIXED inc = toFIXED(0.1);
  
  pos[S] += inc ;
  if ((pos[S]>toFIXED(3.0))||(pos[S]<toFIXED(1.0))){
    inc = slMulFX(toFIXED(-1.0),inc);
  }

  int spr_num = SP_BUT_READY;
  attr[spr_num].atrb =  CL256Bnk|CL_Gouraud;
  attr[spr_num].gstb = GRaddr + minmaxrndint(0,16);
  slDispSprite(pos, (SPR_ATTR *)(&attr[spr_num]),0x0);   
  
}

void sm_randomize_players(GAME* g){

  int i,j,to;
  i=0;
  for (j=0;j<MAX_PLAYER;j++){
    if (g->p[j].active){
      for (to=0;to<10;to++){
	g->p[j].posx = slMulFX(slRandom()-toFIXED(0.5),toFIXED(320.0));
	g->p[j].level = minmaxrndint(0,N_LEVEL-1);
	for (i=0;i<MAX_PLAYER;i++){
	  if (i<=j){
	    if (g->p[i].active){
	      player_display(&(g->p[i]));
	      player_fall(&(g->p[i]));
	    }
	  }
	}
	sm_display_prepare();
	slSynch();
	contest_return();

      }
    }
  }

  for (j=0;j<MAX_PLAYER;j++){
    g->p[i].posy=0;
  }
}



void sub_match(GAME* g){
  int i;
  int j;
  int end=FALSE;
  int interupt=FALSE;
  int pause=0;
  
  int npause = sm_get_n_h_player(g)/2;

  sound_tell_more(vs_sine,0,100,0,0x69ce);
  sound_tell_more(vs_sine,0,100,0,0x68ce);
  sound_tell_more(vs_sine,0,100,0,0x67ce);
  sound_tell_more(vs_sine,0,100,0,0x66ce);

  sound_step();

  //  cdsound_play(3,3,0);

  backimg_set_pal(PN_GAME);
  //  backimg_set_pal(0);
  backimg_mosaic_goto(SC_GAME,1);

  sm_randomize_players(g);

  while (!end) {

    if (sm_check_pause_command(npause)){
      sound_tell(vs_sine,0);
      sound_tell(vs_sine,0);
      sound_tell(vs_sine,0);
      pause = !pause;
    }

    for (i=0;i<MAX_PLAYER;i++){
      PLAYER* p = &(g->p[i]);
      if (p->active) {
	if (!pause){
	  player_update_from_control(p,g->flags,g);
	  for (j=0;j<MAX_PLAYER;j++){
	    PLAYER* v = &(g->p[j]);
	    if (v->active){
	      if (g->flags&GA_TEAM){
		if ((p->team != v->team))
		  player_collide(p,v);
				
	      } else {
		player_collide(p,v);
	      }

	    }
	  }
	}
	player_check_boundaries(p);
	player_display(p);
      }
    }
    
    if (!pause){

      stats_reset();
      for (i=0;i<MAX_PLAYER;i++){
	PLAYER* p = &(g->p[i]);
	if (p->active){
	  player_apply_damage(&(g->p[i]),g->flags);
	}
      }
      stats_draw();

      if (g->flags&GA_TRUCK){
	CAMION * c = &(g->c);
	int drop = camion_run(c);

	if (drop == 1) {
	  game_item_set(g,c->posx, c->level,ic_beer);
	  sound_tell(vs_sirene,1);
   
	}
       	if (slRandom()>toFIXED(0.999)) 
	  camion_arm(c);
	
	game_check_camion(g);
	game_check_items(g);
      }

    }
    for (i=0;i<MAX_ITEM;i++)
      item_display(&(g->it[i]));
    expl_display_all();
    camion_display(&(g->c));

    if (pause) {
      for (i=0;i<MAX_PAD;i++){
	if ((~(Smpc_Peripheral[p_pad[i]].push))&PER_DGT_TX){
	  sm_add_player(g,p_pad[i]);
	}
      }
      

      sm_display_pause_buttons();
      if (pad_someone_presses(PER_DGT_TC,TRUE))
	interupt = TRUE;
    }

    
    sound_step();
    slSynch();
    contest_return();

    

    if (!pause)
      end = game_can_end(g);

    if (!end){
      end = interupt;
    }
  }
  //  cdsound_stop();
}

/*
 * END SCORES
 */

int compute_team_scores(GAME* g,int* score){

  int i;
  int best=0;

  for (i=0;i<MAX_TEAM;i++)
    score[i]=0;

  for (i=0;i<MAX_PLAYER;i++){
    PLAYER* p =  &(g->p[i]);
    if (p->active){
      score[p->team]+=p->score;
      if (g->flags & GA_TEAM){
	best = ((score[p->team])>best)?score[p->team]:best;
      } else {
	best = (p->score>best)?p->score:best;
      }
    }
  }
  
  return best;
}


void sr_display_buttons(){
  static FIXED posA[] = {toFIXED(30.0),toFIXED(100.0),toFIXED(169.0),toFIXED(1.0)};
  static FIXED incA = toFIXED(0.02);

  static FIXED posB[] = {toFIXED(110.0),toFIXED(100.0),toFIXED(169.0),toFIXED(1.1)};
  static FIXED incB = toFIXED(0.02);
  
  posA[S] += incA ;
  if ((posA[S]>toFIXED(1.2))||(posA[S]<toFIXED(1.0))){
    incA = slMulFX(toFIXED(-1.0),incA);
  }
  posB[S] += incB ;
  if ((posB[S]>toFIXED(1.2))||(posB[S]<toFIXED(1.0))){
    incB = slMulFX(toFIXED(-1.0),incB);
  }

  int spr_num = SP_BUT_A1;
  attr[spr_num].atrb =  CL256Bnk;//|CL_Gouraud;
  //  attr[spr_num].gstb = GRaddr + minmaxrndint(0,16);

  slDispSprite(posA, (SPR_ATTR *)(&attr[spr_num]),0x0);   

  spr_num = SP_BUT_B1;
  attr[spr_num].atrb =  CL256Bnk;//|CL_Gouraud;
  //  attr[spr_num].gstb = GRaddr + minmaxrndint(0,16);

  slDispSprite(posB, (SPR_ATTR *)(&attr[spr_num]),0x0);   
  
}

void  sr_display_arrow(PLAYER* p){
  static FIXED pos[] = {toFIXED(100.0),toFIXED(100.0),toFIXED(169.0),toFIXED(0.5)};
  static FIXED inc = toFIXED(0.05);
  static ANGLE ang =DEGtoANG(90.0);
  static ANGLE ainc = DEGtoANG(0.5);
  FIXED py=0;

  pos[S] += inc ;
  if ((pos[S]>toFIXED(0.5))||(pos[S]<toFIXED(2.0))){
    inc = slMulFX(toFIXED(-1.0),inc);
  }
  ang += ainc;
  if ((ang>DEGtoANG(110.0))||(ang<DEGtoANG(60.0))){
    ainc = slMulFX(toFIXED(-1.0),ainc);
  }

  pos[X] = p->posx;
  player_get_high(p,&py);
  pos[Y] = py-slMulFX(toFIXED(16.0),p->size);

  int spr_num = SP_BUT_ARROW;
  attr[spr_num].atrb =  CL256Bnk;//|CL_Gouraud;
  //  attr[spr_num].gstb = GRaddr + minmaxrndint(0,16);
  slDispSprite(pos, (SPR_ATTR *)(&attr[spr_num]),ang);   
}

int sub_resu(GAME* g){
  int score[MAX_TEAM];
  int over = FALSE;
  int i;
  int timeout = 40;
  int col=0;

  clear_screen();
  
  int bestscore = compute_team_scores(g,score);

  for (i=0;i<MAX_PLAYER;i++){
    PLAYER* p =  &(g->p[i]);
    p->posx = slMulFX(p->posx,toFIXED(0.9));
  }
  
  
  do {
    backimg_set_pal(PN_RESU);
    
    if (timeout<-200){
      //      slBMBoxFill(-160+160,-120+120,160+160,120+120,col++);
    }
    col=col%256;
    for (i=0;i<MAX_PLAYER;i++){
      PLAYER* p =  &(g->p[i]);
      if (p->active){ 
	
	if (g->flags & GA_TEAM){
	  p->size = toFIXED(1.0+score[p->team]/(bestscore*0.5));
	  if (score[p->team] == bestscore) {
	    sr_display_arrow(p);
	  }
	} else {
	  p->size = toFIXED(1.0+p->score/(bestscore*0.5));
	  if (p->score == bestscore) {
	    sr_display_arrow(p);
	  }
	}
	player_display(p);     
      }
    }
    if (timeout<0){
      sr_display_buttons();
    }
    sound_step();
    slSynch();
    contest_return();
    over = (pad_someone_presses(PER_DGT_TB,FALSE)||pad_someone_presses(PER_DGT_TA,FALSE));
    over = (over&&(timeout<0)); 
    timeout--;
  } while (!over);

  clear_screen();

  return (pad_someone_presses(PER_DGT_TA,FALSE));
}

/*
 * MAIN
 */

void ss_main() {
  int replay = FALSE;

  slTVOff();
  int i;

  GAME g;
  gfx_init();
  sound_init();

  //  cdsound_init();
  backimg_init();

  init_collision_data();

  sub_intro();  

  slTVOff();
  backimg_mosaic_init();

  //  test_lines();

  // debug_sound();
  // sound_test();
  //  debug_display_all_sprites();  
  //  debug_gouraud();  
 
  game_init(&g);

  for (;;) {
    
    slTVOff();
    backimg_mosaic_renew_game_screen();

    game_reinit(&g);     
    slTVOn();

    if (!replay) {
      sub_title();
      clear_screen();
      sub_game_type(&g);
      sub_players_and_teams(&g);
  
      /*      for (i=0;i<MAX_PLAYER;i++){
	      if (!(g.p[i].active)){
	      g.p[i].active = TRUE;
	      g.p[i].pad_num = -1;
	      player_change_team(&(g.p[i]),minmaxrndint(0,MAX_TEAM-1));
	      g.p[i].level = (i%N_LEVEL);
	      }
	      }*/
    }

    //    clear_screen();
    if (g.flags & GA_TEAM) for (i=0;i<MAX_PLAYER;i++) orteams[i]=g.p[i].team;
    sub_match(&g);
    replay = sub_resu(&g);
    if (g.flags & GA_TEAM) for (i=0;i<MAX_PLAYER;i++) g.p[i].team=orteams[i];

    sound_tell(vs_crunch,1);
  }
}
